Bug 701845 (shunit2) - Review Request: shunit2 - A xUnit based unit testing for Unix shell scripts
Summary: Review Request: shunit2 - A xUnit based unit testing for Unix shell scripts
Keywords:
Status: CLOSED ERRATA
Alias: shunit2
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Daiki Ueno
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-05-04 03:18 UTC by Hushan Jia
Modified: 2011-06-06 21:34 UTC (History)
3 users (show)

Fixed In Version: shunit2-2.1.6-3.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-05-25 02:50:19 UTC
Type: ---
dueno: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Hushan Jia 2011-05-04 03:18:58 UTC
Spec URL: http://hushan.fedorapeople.org/pkgs/shunit2.spec
SRPM URL: http://hushan.fedorapeople.org/pkgs/shunit2-2.1.6-1.el6.src.rpm
Description:
shUnit2 is a xUnit unit test framework for Bourne based shell scripts,
and it is designed to work in a similar manner to JUnit, PyUnit, etc.
If you have ever had the desire to write a unit test for a shell script,
shUnit2 can do the job.

Comment 1 Hushan Jia 2011-05-04 03:26:46 UTC
rpmlint:
$ rpmlint SPECS/shunit2.spec /home/rpmbuild/SRPMS/shunit2-2.1.6-1.el6.src.rpm /home/rpmbuild/RPMS/noarch/shunit2-2.1.6-1.el6.noarch.rpm
shunit2.src: W: spelling-error Summary(en_US) xUnit -> x Unit, unit, Unitas
shunit2.src: W: spelling-error %description -l en_US shUnit -> sh Unit, shunt, sh-unit
shunit2.src: W: spelling-error %description -l en_US xUnit -> x Unit, unit, Unitas
shunit2.src: W: spelling-error %description -l en_US Bourne -> Borne, Bournemouth, Melbourne
shunit2.src: W: spelling-error %description -l en_US JUnit -> J Unit, Unit, Jun it
shunit2.noarch: W: spelling-error Summary(en_US) xUnit -> x Unit, unit, Unitas
shunit2.noarch: W: spelling-error %description -l en_US shUnit -> sh Unit, shunt, sh-unit
shunit2.noarch: W: spelling-error %description -l en_US xUnit -> x Unit, unit, Unitas
shunit2.noarch: W: spelling-error %description -l en_US Bourne -> Borne, Bournemouth, Melbourne
shunit2.noarch: W: spelling-error %description -l en_US JUnit -> J Unit, Unit, Jun it
2 packages and 1 specfiles checked; 0 errors, 10 warnings.

scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3048945

Comment 2 Daiki Ueno 2011-05-17 02:32:29 UTC
Here is the review:

 [+]:ok, [=]:needs attention, [-]:needs fixing, [ ]: not applicable

MUST Items:
[-] MUST: rpmlint must be run on every package.

After installing, rpmlint -i shunit2 gives an error:

  shunit2.noarch: E: incorrect-fsf-address /usr/share/doc/shunit2-2.1.6/LGPL-2.1
  The Free Software Foundation address in this file seems to be outdated or
  misspelled.  Ask upstream to update the address, or if this is a license file,
  possibly the entire file with a new copy available from the FSF.

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.

  4af955ef88c454808754939c83afa22b  shunit2-2.1.6.tgz
  4af955ef88c454808754939c83afa22b  shunit2-2.1.6.tgz.upstream

[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires
[ ] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro.
[ ] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[ ] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[-] MUST: A package must not contain any duplicate files in the %files listing.

It seems that "%doc %{_docdir}/%{name}-%{version}/*" covers "%doc
%{_docdir}/%{name}-%{version}/examples/*" too.

  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples
  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples/equality_test.sh
  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples/lineno_test.sh
  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples/math.inc
  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples/math_test.sh
  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples/mkdir_test.sh
  warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples/party_test.sh

[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissible content. This is described in detail in the code vs. content section of Packaging Guidelines.
[+] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[ ] MUST: Header files must be in a -devel package.
[ ] MUST: Static libraries must be in a -static package.
[ ] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[ ] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[ ] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[+] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[ ] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[ ] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[ ] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[=] SHOULD: The reviewer should test that the package functions as described.

I could run /usr/share/doc/shunit2-2.1.6/examples/equality_test.sh.  Perhaps the examples should be modified to do ". /usr/share/shunit2/shunit2" instead of ". ../src/shunit2"?

[ ] SHOULD: If scriptlets are used, those scriptlets must be sane.
[ ] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[ ] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[ ] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[+] SHOULD: Packages should try to preserve timestamps of original installed files.

Suggestions:
You could drop preparing/cleaning buildroot if you build this package for F-13 or later.

Comment 3 Hushan Jia 2011-05-17 04:15:33 UTC
Hi Daiki,
I have fix the 3 issues, please review:

http://hushan.fedorapeople.org/pkgs/shunit2.spec
http://hushan.fedorapeople.org/pkgs/shunit2-2.1.6-2.el6.src.rpm

I plan to build for EPEL, so cleaning buildroot is required.

Comment 4 Daiki Ueno 2011-05-17 06:06:17 UTC
It still warns about duplicate files:

 warning: File listed twice: /usr/share/doc/shunit2-2.1.6/examples

We could simply change:

 %dir %{_docdir}/%{name}-%{version}
 %dir %{_docdir}/%{name}-%{version}/examples
 %doc %{_docdir}/%{name}-%{version}/*

to:

 %{_docdir}/%{name}-%{version}

?  Even then, files under %{_docdir} seems to be automatically marked as %doc.

Except for this, the packaging looks fine.  APPROVED.

Comment 5 Hushan Jia 2011-05-17 08:12:28 UTC
New Package SCM Request
=======================
Package Name: shunit2
Short Description: shUnit2 is a xUnit unit test framework for Bourne based shell scripts, and it is designed to work in a similar manner to JUnit, PyUnit, etc.
If you have ever had the desire to write a unit test for a shell script, shUnit2 can do the job.
Owners: hushan
Branches: f13 f14 f15 el5 el6

Comment 7 Jason Tibbitts 2011-05-18 22:22:07 UTC
Is it possible to get a "Short Description" that is actually short?  Is there any reason not to use the package Summary:?

Comment 8 Hushan Jia 2011-05-18 23:59:36 UTC
ah, sorry, fixed now:

New Package SCM Request
=======================
Package Name: shunit2
Short Description: A xUnit based unit testing for Unix shell scripts
Owners: hushan
Branches: f13 f14 f15 el5 el6
InitialCC:

Comment 9 Jason Tibbitts 2011-05-19 00:51:15 UTC
Why did you set needinfo to me?  If you have the fedora-cvs flag set, your SCM request will be processed when an admin next runs the script.

Comment 10 Jason Tibbitts 2011-05-19 15:56:59 UTC
Git done (by process-git-requests).

Comment 11 Fedora Update System 2011-05-20 02:46:53 UTC
shunit2-2.1.6-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/shunit2-2.1.6-3.fc15

Comment 12 Fedora Update System 2011-05-20 02:59:45 UTC
shunit2-2.1.6-3.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/shunit2-2.1.6-3.fc13

Comment 13 Fedora Update System 2011-05-20 03:01:10 UTC
shunit2-2.1.6-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/shunit2-2.1.6-3.fc14

Comment 14 Fedora Update System 2011-05-20 03:07:35 UTC
shunit2-2.1.6-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/shunit2-2.1.6-3.el6

Comment 15 Fedora Update System 2011-05-20 03:14:29 UTC
shunit2-2.1.6-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/shunit2-2.1.6-3.el5

Comment 16 Hushan Jia 2011-05-20 03:21:57 UTC
Thanks Daiki and Jason, updates have been submitted.

Comment 17 Fedora Update System 2011-05-20 17:54:08 UTC
shunit2-2.1.6-3.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 18 Fedora Update System 2011-05-25 02:50:13 UTC
shunit2-2.1.6-3.fc15 has been pushed to the Fedora 15 stable repository.

Comment 19 Fedora Update System 2011-05-28 23:54:34 UTC
shunit2-2.1.6-3.fc13 has been pushed to the Fedora 13 stable repository.

Comment 20 Fedora Update System 2011-05-29 00:02:03 UTC
shunit2-2.1.6-3.fc14 has been pushed to the Fedora 14 stable repository.

Comment 21 Fedora Update System 2011-06-06 21:32:42 UTC
shunit2-2.1.6-3.el5 has been pushed to the Fedora EPEL 5 stable repository.

Comment 22 Fedora Update System 2011-06-06 21:34:20 UTC
shunit2-2.1.6-3.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.